=begin
#Pulp 3 API

#Fetch, Upload, Organize, and Distribute Software Packages

The version of the OpenAPI document: v3
Contact: pulp-list@redhat.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.3.1

=end

require 'cgi'

module PulpContainerClient
  class ContentSignaturesApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # List manifest signatures
    # ViewSet for image signatures.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :digest Filter results where digest matches value
    # @option opts [Array<String>] :digest__in Filter results where digest is in a comma-separated list of values
    # @option opts [String] :key_id Filter results where key_id matches value
    # @option opts [Array<String>] :key_id__in Filter results where key_id is in a comma-separated list of values
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [Array<String>] :manifest Multiple values may be separated by commas.
    # @option opts [String] :name Filter results where name matches value
    # @option opts [String] :name__contains Filter results where name contains value
    # @option opts [String] :name__icontains Filter results where name contains value
    # @option opts [Array<String>] :name__in Filter results where name is in a comma-separated list of values
    # @option opts [String] :name__startswith Filter results where name starts with value
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [Array<String>] :ordering Ordering
    # @option opts [String] :repository_version Repository Version referenced by HREF
    # @option opts [String] :repository_version_added Repository Version referenced by HREF
    # @option opts [String] :repository_version_removed Repository Version referenced by HREF
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [PaginatedcontainerManifestSignatureResponseList]
    def list(opts = {})
      data, _status_code, _headers = list_with_http_info(opts)
      data
    end

    # List manifest signatures
    # ViewSet for image signatures.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :digest Filter results where digest matches value
    # @option opts [Array<String>] :digest__in Filter results where digest is in a comma-separated list of values
    # @option opts [String] :key_id Filter results where key_id matches value
    # @option opts [Array<String>] :key_id__in Filter results where key_id is in a comma-separated list of values
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [Array<String>] :manifest Multiple values may be separated by commas.
    # @option opts [String] :name Filter results where name matches value
    # @option opts [String] :name__contains Filter results where name contains value
    # @option opts [String] :name__icontains Filter results where name contains value
    # @option opts [Array<String>] :name__in Filter results where name is in a comma-separated list of values
    # @option opts [String] :name__startswith Filter results where name starts with value
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [Array<String>] :ordering Ordering
    # @option opts [String] :repository_version Repository Version referenced by HREF
    # @option opts [String] :repository_version_added Repository Version referenced by HREF
    # @option opts [String] :repository_version_removed Repository Version referenced by HREF
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(PaginatedcontainerManifestSignatureResponseList, Integer, Hash)>] PaginatedcontainerManifestSignatureResponseList data, response status code and response headers
    def list_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ContentSignaturesApi.list ...'
      end
      allowable_values = ["-_artifacts", "-content_ptr", "-contentartifact", "-creator", "-data", "-digest", "-group_roles", "-key_id", "-name", "-pk", "-pulp_created", "-pulp_id", "-pulp_labels", "-pulp_last_updated", "-pulp_type", "-repositories", "-signed_manifest", "-timestamp", "-timestamp_of_interest", "-type", "-upstream_id", "-user_roles", "-version_memberships", "_artifacts", "content_ptr", "contentartifact", "creator", "data", "digest", "group_roles", "key_id", "name", "pk", "pulp_created", "pulp_id", "pulp_labels", "pulp_last_updated", "pulp_type", "repositories", "signed_manifest", "timestamp", "timestamp_of_interest", "type", "upstream_id", "user_roles", "version_memberships"]
      if @api_client.config.client_side_validation && opts[:'ordering'] && !opts[:'ordering'].all? { |item| allowable_values.include?(item) }
        fail ArgumentError, "invalid value for \"ordering\", must include one of #{allowable_values}"
      end
      # resource path
      local_var_path = '/pulp/api/v3/content/container/signatures/'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'digest'] = opts[:'digest'] if !opts[:'digest'].nil?
      query_params[:'digest__in'] = @api_client.build_collection_param(opts[:'digest__in'], :csv) if !opts[:'digest__in'].nil?
      query_params[:'key_id'] = opts[:'key_id'] if !opts[:'key_id'].nil?
      query_params[:'key_id__in'] = @api_client.build_collection_param(opts[:'key_id__in'], :csv) if !opts[:'key_id__in'].nil?
      query_params[:'limit'] = opts[:'limit'] if !opts[:'limit'].nil?
      query_params[:'manifest'] = @api_client.build_collection_param(opts[:'manifest'], :csv) if !opts[:'manifest'].nil?
      query_params[:'name'] = opts[:'name'] if !opts[:'name'].nil?
      query_params[:'name__contains'] = opts[:'name__contains'] if !opts[:'name__contains'].nil?
      query_params[:'name__icontains'] = opts[:'name__icontains'] if !opts[:'name__icontains'].nil?
      query_params[:'name__in'] = @api_client.build_collection_param(opts[:'name__in'], :csv) if !opts[:'name__in'].nil?
      query_params[:'name__startswith'] = opts[:'name__startswith'] if !opts[:'name__startswith'].nil?
      query_params[:'offset'] = opts[:'offset'] if !opts[:'offset'].nil?
      query_params[:'ordering'] = @api_client.build_collection_param(opts[:'ordering'], :csv) if !opts[:'ordering'].nil?
      query_params[:'repository_version'] = opts[:'repository_version'] if !opts[:'repository_version'].nil?
      query_params[:'repository_version_added'] = opts[:'repository_version_added'] if !opts[:'repository_version_added'].nil?
      query_params[:'repository_version_removed'] = opts[:'repository_version_removed'] if !opts[:'repository_version_removed'].nil?
      query_params[:'fields'] = opts[:'fields'] if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = opts[:'exclude_fields'] if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'PaginatedcontainerManifestSignatureResponseList' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ContentSignaturesApi#list\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Inspect a manifest signature
    # ViewSet for image signatures.
    # @param container_manifest_signature_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [ContainerManifestSignatureResponse]
    def read(container_manifest_signature_href, opts = {})
      data, _status_code, _headers = read_with_http_info(container_manifest_signature_href, opts)
      data
    end

    # Inspect a manifest signature
    # ViewSet for image signatures.
    # @param container_manifest_signature_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(ContainerManifestSignatureResponse, Integer, Hash)>] ContainerManifestSignatureResponse data, response status code and response headers
    def read_with_http_info(container_manifest_signature_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ContentSignaturesApi.read ...'
      end
      # verify the required parameter 'container_manifest_signature_href' is set
      if @api_client.config.client_side_validation && container_manifest_signature_href.nil?
        fail ArgumentError, "Missing the required parameter 'container_manifest_signature_href' when calling ContentSignaturesApi.read"
      end
      # resource path
      local_var_path = '{container_manifest_signature_href}'.sub('{' + 'container_manifest_signature_href' + '}', CGI.escape(container_manifest_signature_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'fields'] = opts[:'fields'] if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = opts[:'exclude_fields'] if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'ContainerManifestSignatureResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ContentSignaturesApi#read\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
