=begin
#Pulp 3 API

#Fetch, Upload, Organize, and Distribute Software Packages

The version of the OpenAPI document: v3
Contact: pulp-list@redhat.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.3.1

=end

require 'cgi'

module PulpContainerClient
  class PulpContainerNamespacesApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Add a role for this object to users/groups.
    # @param container_container_namespace_href [String] 
    # @param nested_role [NestedRole] 
    # @param [Hash] opts the optional parameters
    # @return [NestedRoleResponse]
    def add_role(container_container_namespace_href, nested_role, opts = {})
      data, _status_code, _headers = add_role_with_http_info(container_container_namespace_href, nested_role, opts)
      data
    end

    # Add a role for this object to users/groups.
    # @param container_container_namespace_href [String] 
    # @param nested_role [NestedRole] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(NestedRoleResponse, Integer, Hash)>] NestedRoleResponse data, response status code and response headers
    def add_role_with_http_info(container_container_namespace_href, nested_role, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PulpContainerNamespacesApi.add_role ...'
      end
      # verify the required parameter 'container_container_namespace_href' is set
      if @api_client.config.client_side_validation && container_container_namespace_href.nil?
        fail ArgumentError, "Missing the required parameter 'container_container_namespace_href' when calling PulpContainerNamespacesApi.add_role"
      end
      # verify the required parameter 'nested_role' is set
      if @api_client.config.client_side_validation && nested_role.nil?
        fail ArgumentError, "Missing the required parameter 'nested_role' when calling PulpContainerNamespacesApi.add_role"
      end
      # resource path
      local_var_path = '{container_container_namespace_href}add_role/'.sub('{' + 'container_container_namespace_href' + '}', CGI.escape(container_container_namespace_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(nested_role) 

      # return_type
      return_type = opts[:return_type] || 'NestedRoleResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PulpContainerNamespacesApi#add_role\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Create a container namespace
    # ViewSet for ContainerNamespaces.
    # @param container_container_namespace [ContainerContainerNamespace] 
    # @param [Hash] opts the optional parameters
    # @return [ContainerContainerNamespaceResponse]
    def create(container_container_namespace, opts = {})
      data, _status_code, _headers = create_with_http_info(container_container_namespace, opts)
      data
    end

    # Create a container namespace
    # ViewSet for ContainerNamespaces.
    # @param container_container_namespace [ContainerContainerNamespace] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(ContainerContainerNamespaceResponse, Integer, Hash)>] ContainerContainerNamespaceResponse data, response status code and response headers
    def create_with_http_info(container_container_namespace, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PulpContainerNamespacesApi.create ...'
      end
      # verify the required parameter 'container_container_namespace' is set
      if @api_client.config.client_side_validation && container_container_namespace.nil?
        fail ArgumentError, "Missing the required parameter 'container_container_namespace' when calling PulpContainerNamespacesApi.create"
      end
      # resource path
      local_var_path = '/pulp/api/v3/pulp_container/namespaces/'

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(container_container_namespace) 

      # return_type
      return_type = opts[:return_type] || 'ContainerContainerNamespaceResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PulpContainerNamespacesApi#create\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Delete a container namespace
    # Trigger an asynchronous delete task
    # @param container_container_namespace_href [String] 
    # @param [Hash] opts the optional parameters
    # @return [AsyncOperationResponse]
    def delete(container_container_namespace_href, opts = {})
      data, _status_code, _headers = delete_with_http_info(container_container_namespace_href, opts)
      data
    end

    # Delete a container namespace
    # Trigger an asynchronous delete task
    # @param container_container_namespace_href [String] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AsyncOperationResponse, Integer, Hash)>] AsyncOperationResponse data, response status code and response headers
    def delete_with_http_info(container_container_namespace_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PulpContainerNamespacesApi.delete ...'
      end
      # verify the required parameter 'container_container_namespace_href' is set
      if @api_client.config.client_side_validation && container_container_namespace_href.nil?
        fail ArgumentError, "Missing the required parameter 'container_container_namespace_href' when calling PulpContainerNamespacesApi.delete"
      end
      # resource path
      local_var_path = '{container_container_namespace_href}'.sub('{' + 'container_container_namespace_href' + '}', CGI.escape(container_container_namespace_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'AsyncOperationResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PulpContainerNamespacesApi#delete\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # List container namespaces
    # ViewSet for ContainerNamespaces.
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [String] :name Filter results where name matches value
    # @option opts [String] :name__contains Filter results where name contains value
    # @option opts [String] :name__icontains Filter results where name contains value
    # @option opts [Array<String>] :name__in Filter results where name is in a comma-separated list of values
    # @option opts [String] :name__startswith Filter results where name starts with value
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [Array<String>] :ordering Ordering
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [PaginatedcontainerContainerNamespaceResponseList]
    def list(opts = {})
      data, _status_code, _headers = list_with_http_info(opts)
      data
    end

    # List container namespaces
    # ViewSet for ContainerNamespaces.
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [String] :name Filter results where name matches value
    # @option opts [String] :name__contains Filter results where name contains value
    # @option opts [String] :name__icontains Filter results where name contains value
    # @option opts [Array<String>] :name__in Filter results where name is in a comma-separated list of values
    # @option opts [String] :name__startswith Filter results where name starts with value
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [Array<String>] :ordering Ordering
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(PaginatedcontainerContainerNamespaceResponseList, Integer, Hash)>] PaginatedcontainerContainerNamespaceResponseList data, response status code and response headers
    def list_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PulpContainerNamespacesApi.list ...'
      end
      allowable_values = ["-container_distributions", "-group_roles", "-name", "-pk", "-pulp_created", "-pulp_id", "-pulp_labels", "-pulp_last_updated", "-user_roles", "container_distributions", "group_roles", "name", "pk", "pulp_created", "pulp_id", "pulp_labels", "pulp_last_updated", "user_roles"]
      if @api_client.config.client_side_validation && opts[:'ordering'] && !opts[:'ordering'].all? { |item| allowable_values.include?(item) }
        fail ArgumentError, "invalid value for \"ordering\", must include one of #{allowable_values}"
      end
      # resource path
      local_var_path = '/pulp/api/v3/pulp_container/namespaces/'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'limit'] = opts[:'limit'] if !opts[:'limit'].nil?
      query_params[:'name'] = opts[:'name'] if !opts[:'name'].nil?
      query_params[:'name__contains'] = opts[:'name__contains'] if !opts[:'name__contains'].nil?
      query_params[:'name__icontains'] = opts[:'name__icontains'] if !opts[:'name__icontains'].nil?
      query_params[:'name__in'] = @api_client.build_collection_param(opts[:'name__in'], :csv) if !opts[:'name__in'].nil?
      query_params[:'name__startswith'] = opts[:'name__startswith'] if !opts[:'name__startswith'].nil?
      query_params[:'offset'] = opts[:'offset'] if !opts[:'offset'].nil?
      query_params[:'ordering'] = @api_client.build_collection_param(opts[:'ordering'], :csv) if !opts[:'ordering'].nil?
      query_params[:'fields'] = opts[:'fields'] if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = opts[:'exclude_fields'] if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'PaginatedcontainerContainerNamespaceResponseList' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PulpContainerNamespacesApi#list\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # List roles assigned to this object.
    # @param container_container_namespace_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [ObjectRolesResponse]
    def list_roles(container_container_namespace_href, opts = {})
      data, _status_code, _headers = list_roles_with_http_info(container_container_namespace_href, opts)
      data
    end

    # List roles assigned to this object.
    # @param container_container_namespace_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(ObjectRolesResponse, Integer, Hash)>] ObjectRolesResponse data, response status code and response headers
    def list_roles_with_http_info(container_container_namespace_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PulpContainerNamespacesApi.list_roles ...'
      end
      # verify the required parameter 'container_container_namespace_href' is set
      if @api_client.config.client_side_validation && container_container_namespace_href.nil?
        fail ArgumentError, "Missing the required parameter 'container_container_namespace_href' when calling PulpContainerNamespacesApi.list_roles"
      end
      # resource path
      local_var_path = '{container_container_namespace_href}list_roles/'.sub('{' + 'container_container_namespace_href' + '}', CGI.escape(container_container_namespace_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'fields'] = opts[:'fields'] if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = opts[:'exclude_fields'] if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'ObjectRolesResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PulpContainerNamespacesApi#list_roles\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # List permissions available to the current user on this object.
    # @param container_container_namespace_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [MyPermissionsResponse]
    def my_permissions(container_container_namespace_href, opts = {})
      data, _status_code, _headers = my_permissions_with_http_info(container_container_namespace_href, opts)
      data
    end

    # List permissions available to the current user on this object.
    # @param container_container_namespace_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(MyPermissionsResponse, Integer, Hash)>] MyPermissionsResponse data, response status code and response headers
    def my_permissions_with_http_info(container_container_namespace_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PulpContainerNamespacesApi.my_permissions ...'
      end
      # verify the required parameter 'container_container_namespace_href' is set
      if @api_client.config.client_side_validation && container_container_namespace_href.nil?
        fail ArgumentError, "Missing the required parameter 'container_container_namespace_href' when calling PulpContainerNamespacesApi.my_permissions"
      end
      # resource path
      local_var_path = '{container_container_namespace_href}my_permissions/'.sub('{' + 'container_container_namespace_href' + '}', CGI.escape(container_container_namespace_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'fields'] = opts[:'fields'] if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = opts[:'exclude_fields'] if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'MyPermissionsResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PulpContainerNamespacesApi#my_permissions\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Inspect a container namespace
    # ViewSet for ContainerNamespaces.
    # @param container_container_namespace_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [ContainerContainerNamespaceResponse]
    def read(container_container_namespace_href, opts = {})
      data, _status_code, _headers = read_with_http_info(container_container_namespace_href, opts)
      data
    end

    # Inspect a container namespace
    # ViewSet for ContainerNamespaces.
    # @param container_container_namespace_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(ContainerContainerNamespaceResponse, Integer, Hash)>] ContainerContainerNamespaceResponse data, response status code and response headers
    def read_with_http_info(container_container_namespace_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PulpContainerNamespacesApi.read ...'
      end
      # verify the required parameter 'container_container_namespace_href' is set
      if @api_client.config.client_side_validation && container_container_namespace_href.nil?
        fail ArgumentError, "Missing the required parameter 'container_container_namespace_href' when calling PulpContainerNamespacesApi.read"
      end
      # resource path
      local_var_path = '{container_container_namespace_href}'.sub('{' + 'container_container_namespace_href' + '}', CGI.escape(container_container_namespace_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'fields'] = opts[:'fields'] if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = opts[:'exclude_fields'] if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'ContainerContainerNamespaceResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PulpContainerNamespacesApi#read\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Remove a role for this object from users/groups.
    # @param container_container_namespace_href [String] 
    # @param nested_role [NestedRole] 
    # @param [Hash] opts the optional parameters
    # @return [NestedRoleResponse]
    def remove_role(container_container_namespace_href, nested_role, opts = {})
      data, _status_code, _headers = remove_role_with_http_info(container_container_namespace_href, nested_role, opts)
      data
    end

    # Remove a role for this object from users/groups.
    # @param container_container_namespace_href [String] 
    # @param nested_role [NestedRole] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(NestedRoleResponse, Integer, Hash)>] NestedRoleResponse data, response status code and response headers
    def remove_role_with_http_info(container_container_namespace_href, nested_role, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PulpContainerNamespacesApi.remove_role ...'
      end
      # verify the required parameter 'container_container_namespace_href' is set
      if @api_client.config.client_side_validation && container_container_namespace_href.nil?
        fail ArgumentError, "Missing the required parameter 'container_container_namespace_href' when calling PulpContainerNamespacesApi.remove_role"
      end
      # verify the required parameter 'nested_role' is set
      if @api_client.config.client_side_validation && nested_role.nil?
        fail ArgumentError, "Missing the required parameter 'nested_role' when calling PulpContainerNamespacesApi.remove_role"
      end
      # resource path
      local_var_path = '{container_container_namespace_href}remove_role/'.sub('{' + 'container_container_namespace_href' + '}', CGI.escape(container_container_namespace_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(nested_role) 

      # return_type
      return_type = opts[:return_type] || 'NestedRoleResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PulpContainerNamespacesApi#remove_role\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
