=begin
#Pulp 3 API

#Fetch, Upload, Organize, and Distribute Software Packages

The version of the OpenAPI document: v3
Contact: pulp-list@redhat.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.3.1

=end

require 'cgi'

module PulpContainerClient
  class RemotesContainerApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Add a role for this object to users/groups.
    # @param container_container_remote_href [String] 
    # @param nested_role [NestedRole] 
    # @param [Hash] opts the optional parameters
    # @return [NestedRoleResponse]
    def add_role(container_container_remote_href, nested_role, opts = {})
      data, _status_code, _headers = add_role_with_http_info(container_container_remote_href, nested_role, opts)
      data
    end

    # Add a role for this object to users/groups.
    # @param container_container_remote_href [String] 
    # @param nested_role [NestedRole] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(NestedRoleResponse, Integer, Hash)>] NestedRoleResponse data, response status code and response headers
    def add_role_with_http_info(container_container_remote_href, nested_role, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: RemotesContainerApi.add_role ...'
      end
      # verify the required parameter 'container_container_remote_href' is set
      if @api_client.config.client_side_validation && container_container_remote_href.nil?
        fail ArgumentError, "Missing the required parameter 'container_container_remote_href' when calling RemotesContainerApi.add_role"
      end
      # verify the required parameter 'nested_role' is set
      if @api_client.config.client_side_validation && nested_role.nil?
        fail ArgumentError, "Missing the required parameter 'nested_role' when calling RemotesContainerApi.add_role"
      end
      # resource path
      local_var_path = '{container_container_remote_href}add_role/'.sub('{' + 'container_container_remote_href' + '}', CGI.escape(container_container_remote_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(nested_role) 

      # return_type
      return_type = opts[:return_type] || 'NestedRoleResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: RemotesContainerApi#add_role\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Create a container remote
    # Container remotes represent an external repository that implements the Container Registry API. Container remotes support deferred downloading by configuring the ``policy`` field.  ``on_demand`` and ``streamed`` policies can provide significant disk space savings.
    # @param container_container_remote [ContainerContainerRemote] 
    # @param [Hash] opts the optional parameters
    # @return [ContainerContainerRemoteResponse]
    def create(container_container_remote, opts = {})
      data, _status_code, _headers = create_with_http_info(container_container_remote, opts)
      data
    end

    # Create a container remote
    # Container remotes represent an external repository that implements the Container Registry API. Container remotes support deferred downloading by configuring the &#x60;&#x60;policy&#x60;&#x60; field.  &#x60;&#x60;on_demand&#x60;&#x60; and &#x60;&#x60;streamed&#x60;&#x60; policies can provide significant disk space savings.
    # @param container_container_remote [ContainerContainerRemote] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(ContainerContainerRemoteResponse, Integer, Hash)>] ContainerContainerRemoteResponse data, response status code and response headers
    def create_with_http_info(container_container_remote, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: RemotesContainerApi.create ...'
      end
      # verify the required parameter 'container_container_remote' is set
      if @api_client.config.client_side_validation && container_container_remote.nil?
        fail ArgumentError, "Missing the required parameter 'container_container_remote' when calling RemotesContainerApi.create"
      end
      # resource path
      local_var_path = '/pulp/api/v3/remotes/container/container/'

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(container_container_remote) 

      # return_type
      return_type = opts[:return_type] || 'ContainerContainerRemoteResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: RemotesContainerApi#create\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Delete a container remote
    # Trigger an asynchronous delete task
    # @param container_container_remote_href [String] 
    # @param [Hash] opts the optional parameters
    # @return [AsyncOperationResponse]
    def delete(container_container_remote_href, opts = {})
      data, _status_code, _headers = delete_with_http_info(container_container_remote_href, opts)
      data
    end

    # Delete a container remote
    # Trigger an asynchronous delete task
    # @param container_container_remote_href [String] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AsyncOperationResponse, Integer, Hash)>] AsyncOperationResponse data, response status code and response headers
    def delete_with_http_info(container_container_remote_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: RemotesContainerApi.delete ...'
      end
      # verify the required parameter 'container_container_remote_href' is set
      if @api_client.config.client_side_validation && container_container_remote_href.nil?
        fail ArgumentError, "Missing the required parameter 'container_container_remote_href' when calling RemotesContainerApi.delete"
      end
      # resource path
      local_var_path = '{container_container_remote_href}'.sub('{' + 'container_container_remote_href' + '}', CGI.escape(container_container_remote_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'AsyncOperationResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: RemotesContainerApi#delete\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # List container remotes
    # Container remotes represent an external repository that implements the Container Registry API. Container remotes support deferred downloading by configuring the ``policy`` field.  ``on_demand`` and ``streamed`` policies can provide significant disk space savings.
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [String] :name 
    # @option opts [String] :name__contains Filter results where name contains value
    # @option opts [String] :name__icontains Filter results where name contains value
    # @option opts [Array<String>] :name__in Filter results where name is in a comma-separated list of values
    # @option opts [String] :name__startswith Filter results where name starts with value
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [Array<String>] :ordering Ordering
    # @option opts [String] :pulp_label_select Filter labels by search string
    # @option opts [DateTime] :pulp_last_updated ISO 8601 formatted dates are supported
    # @option opts [DateTime] :pulp_last_updated__gt Filter results where pulp_last_updated is greater than value
    # @option opts [DateTime] :pulp_last_updated__gte Filter results where pulp_last_updated is greater than or equal to value
    # @option opts [DateTime] :pulp_last_updated__lt Filter results where pulp_last_updated is less than value
    # @option opts [DateTime] :pulp_last_updated__lte Filter results where pulp_last_updated is less than or equal to value
    # @option opts [Array<DateTime>] :pulp_last_updated__range Filter results where pulp_last_updated is between two comma separated values
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [PaginatedcontainerContainerRemoteResponseList]
    def list(opts = {})
      data, _status_code, _headers = list_with_http_info(opts)
      data
    end

    # List container remotes
    # Container remotes represent an external repository that implements the Container Registry API. Container remotes support deferred downloading by configuring the &#x60;&#x60;policy&#x60;&#x60; field.  &#x60;&#x60;on_demand&#x60;&#x60; and &#x60;&#x60;streamed&#x60;&#x60; policies can provide significant disk space savings.
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [String] :name 
    # @option opts [String] :name__contains Filter results where name contains value
    # @option opts [String] :name__icontains Filter results where name contains value
    # @option opts [Array<String>] :name__in Filter results where name is in a comma-separated list of values
    # @option opts [String] :name__startswith Filter results where name starts with value
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [Array<String>] :ordering Ordering
    # @option opts [String] :pulp_label_select Filter labels by search string
    # @option opts [DateTime] :pulp_last_updated ISO 8601 formatted dates are supported
    # @option opts [DateTime] :pulp_last_updated__gt Filter results where pulp_last_updated is greater than value
    # @option opts [DateTime] :pulp_last_updated__gte Filter results where pulp_last_updated is greater than or equal to value
    # @option opts [DateTime] :pulp_last_updated__lt Filter results where pulp_last_updated is less than value
    # @option opts [DateTime] :pulp_last_updated__lte Filter results where pulp_last_updated is less than or equal to value
    # @option opts [Array<DateTime>] :pulp_last_updated__range Filter results where pulp_last_updated is between two comma separated values
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(PaginatedcontainerContainerRemoteResponseList, Integer, Hash)>] PaginatedcontainerContainerRemoteResponseList data, response status code and response headers
    def list_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: RemotesContainerApi.list ...'
      end
      allowable_values = ["-alternatecontentsource", "-basedistribution", "-ca_cert", "-client_cert", "-client_key", "-connect_timeout", "-container_containerremote", "-distribution", "-download_concurrency", "-group_roles", "-headers", "-max_retries", "-name", "-password", "-pk", "-policy", "-proxy_password", "-proxy_url", "-proxy_username", "-pulp_created", "-pulp_id", "-pulp_labels", "-pulp_last_updated", "-pulp_type", "-rate_limit", "-remoteartifact", "-repository", "-sock_connect_timeout", "-sock_read_timeout", "-tls_validation", "-total_timeout", "-url", "-user_roles", "-username", "alternatecontentsource", "basedistribution", "ca_cert", "client_cert", "client_key", "connect_timeout", "container_containerremote", "distribution", "download_concurrency", "group_roles", "headers", "max_retries", "name", "password", "pk", "policy", "proxy_password", "proxy_url", "proxy_username", "pulp_created", "pulp_id", "pulp_labels", "pulp_last_updated", "pulp_type", "rate_limit", "remoteartifact", "repository", "sock_connect_timeout", "sock_read_timeout", "tls_validation", "total_timeout", "url", "user_roles", "username"]
      if @api_client.config.client_side_validation && opts[:'ordering'] && !opts[:'ordering'].all? { |item| allowable_values.include?(item) }
        fail ArgumentError, "invalid value for \"ordering\", must include one of #{allowable_values}"
      end
      # resource path
      local_var_path = '/pulp/api/v3/remotes/container/container/'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'limit'] = opts[:'limit'] if !opts[:'limit'].nil?
      query_params[:'name'] = opts[:'name'] if !opts[:'name'].nil?
      query_params[:'name__contains'] = opts[:'name__contains'] if !opts[:'name__contains'].nil?
      query_params[:'name__icontains'] = opts[:'name__icontains'] if !opts[:'name__icontains'].nil?
      query_params[:'name__in'] = @api_client.build_collection_param(opts[:'name__in'], :csv) if !opts[:'name__in'].nil?
      query_params[:'name__startswith'] = opts[:'name__startswith'] if !opts[:'name__startswith'].nil?
      query_params[:'offset'] = opts[:'offset'] if !opts[:'offset'].nil?
      query_params[:'ordering'] = @api_client.build_collection_param(opts[:'ordering'], :csv) if !opts[:'ordering'].nil?
      query_params[:'pulp_label_select'] = opts[:'pulp_label_select'] if !opts[:'pulp_label_select'].nil?
      query_params[:'pulp_last_updated'] = opts[:'pulp_last_updated'] if !opts[:'pulp_last_updated'].nil?
      query_params[:'pulp_last_updated__gt'] = opts[:'pulp_last_updated__gt'] if !opts[:'pulp_last_updated__gt'].nil?
      query_params[:'pulp_last_updated__gte'] = opts[:'pulp_last_updated__gte'] if !opts[:'pulp_last_updated__gte'].nil?
      query_params[:'pulp_last_updated__lt'] = opts[:'pulp_last_updated__lt'] if !opts[:'pulp_last_updated__lt'].nil?
      query_params[:'pulp_last_updated__lte'] = opts[:'pulp_last_updated__lte'] if !opts[:'pulp_last_updated__lte'].nil?
      query_params[:'pulp_last_updated__range'] = @api_client.build_collection_param(opts[:'pulp_last_updated__range'], :csv) if !opts[:'pulp_last_updated__range'].nil?
      query_params[:'fields'] = opts[:'fields'] if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = opts[:'exclude_fields'] if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'PaginatedcontainerContainerRemoteResponseList' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: RemotesContainerApi#list\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # List roles assigned to this object.
    # @param container_container_remote_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [ObjectRolesResponse]
    def list_roles(container_container_remote_href, opts = {})
      data, _status_code, _headers = list_roles_with_http_info(container_container_remote_href, opts)
      data
    end

    # List roles assigned to this object.
    # @param container_container_remote_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(ObjectRolesResponse, Integer, Hash)>] ObjectRolesResponse data, response status code and response headers
    def list_roles_with_http_info(container_container_remote_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: RemotesContainerApi.list_roles ...'
      end
      # verify the required parameter 'container_container_remote_href' is set
      if @api_client.config.client_side_validation && container_container_remote_href.nil?
        fail ArgumentError, "Missing the required parameter 'container_container_remote_href' when calling RemotesContainerApi.list_roles"
      end
      # resource path
      local_var_path = '{container_container_remote_href}list_roles/'.sub('{' + 'container_container_remote_href' + '}', CGI.escape(container_container_remote_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'fields'] = opts[:'fields'] if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = opts[:'exclude_fields'] if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'ObjectRolesResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: RemotesContainerApi#list_roles\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # List permissions available to the current user on this object.
    # @param container_container_remote_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [MyPermissionsResponse]
    def my_permissions(container_container_remote_href, opts = {})
      data, _status_code, _headers = my_permissions_with_http_info(container_container_remote_href, opts)
      data
    end

    # List permissions available to the current user on this object.
    # @param container_container_remote_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(MyPermissionsResponse, Integer, Hash)>] MyPermissionsResponse data, response status code and response headers
    def my_permissions_with_http_info(container_container_remote_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: RemotesContainerApi.my_permissions ...'
      end
      # verify the required parameter 'container_container_remote_href' is set
      if @api_client.config.client_side_validation && container_container_remote_href.nil?
        fail ArgumentError, "Missing the required parameter 'container_container_remote_href' when calling RemotesContainerApi.my_permissions"
      end
      # resource path
      local_var_path = '{container_container_remote_href}my_permissions/'.sub('{' + 'container_container_remote_href' + '}', CGI.escape(container_container_remote_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'fields'] = opts[:'fields'] if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = opts[:'exclude_fields'] if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'MyPermissionsResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: RemotesContainerApi#my_permissions\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Update a container remote
    # Trigger an asynchronous partial update task
    # @param container_container_remote_href [String] 
    # @param patchedcontainer_container_remote [PatchedcontainerContainerRemote] 
    # @param [Hash] opts the optional parameters
    # @return [AsyncOperationResponse]
    def partial_update(container_container_remote_href, patchedcontainer_container_remote, opts = {})
      data, _status_code, _headers = partial_update_with_http_info(container_container_remote_href, patchedcontainer_container_remote, opts)
      data
    end

    # Update a container remote
    # Trigger an asynchronous partial update task
    # @param container_container_remote_href [String] 
    # @param patchedcontainer_container_remote [PatchedcontainerContainerRemote] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AsyncOperationResponse, Integer, Hash)>] AsyncOperationResponse data, response status code and response headers
    def partial_update_with_http_info(container_container_remote_href, patchedcontainer_container_remote, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: RemotesContainerApi.partial_update ...'
      end
      # verify the required parameter 'container_container_remote_href' is set
      if @api_client.config.client_side_validation && container_container_remote_href.nil?
        fail ArgumentError, "Missing the required parameter 'container_container_remote_href' when calling RemotesContainerApi.partial_update"
      end
      # verify the required parameter 'patchedcontainer_container_remote' is set
      if @api_client.config.client_side_validation && patchedcontainer_container_remote.nil?
        fail ArgumentError, "Missing the required parameter 'patchedcontainer_container_remote' when calling RemotesContainerApi.partial_update"
      end
      # resource path
      local_var_path = '{container_container_remote_href}'.sub('{' + 'container_container_remote_href' + '}', CGI.escape(container_container_remote_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(patchedcontainer_container_remote) 

      # return_type
      return_type = opts[:return_type] || 'AsyncOperationResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: RemotesContainerApi#partial_update\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Inspect a container remote
    # Container remotes represent an external repository that implements the Container Registry API. Container remotes support deferred downloading by configuring the ``policy`` field.  ``on_demand`` and ``streamed`` policies can provide significant disk space savings.
    # @param container_container_remote_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [ContainerContainerRemoteResponse]
    def read(container_container_remote_href, opts = {})
      data, _status_code, _headers = read_with_http_info(container_container_remote_href, opts)
      data
    end

    # Inspect a container remote
    # Container remotes represent an external repository that implements the Container Registry API. Container remotes support deferred downloading by configuring the &#x60;&#x60;policy&#x60;&#x60; field.  &#x60;&#x60;on_demand&#x60;&#x60; and &#x60;&#x60;streamed&#x60;&#x60; policies can provide significant disk space savings.
    # @param container_container_remote_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(ContainerContainerRemoteResponse, Integer, Hash)>] ContainerContainerRemoteResponse data, response status code and response headers
    def read_with_http_info(container_container_remote_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: RemotesContainerApi.read ...'
      end
      # verify the required parameter 'container_container_remote_href' is set
      if @api_client.config.client_side_validation && container_container_remote_href.nil?
        fail ArgumentError, "Missing the required parameter 'container_container_remote_href' when calling RemotesContainerApi.read"
      end
      # resource path
      local_var_path = '{container_container_remote_href}'.sub('{' + 'container_container_remote_href' + '}', CGI.escape(container_container_remote_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'fields'] = opts[:'fields'] if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = opts[:'exclude_fields'] if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'ContainerContainerRemoteResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: RemotesContainerApi#read\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Remove a role for this object from users/groups.
    # @param container_container_remote_href [String] 
    # @param nested_role [NestedRole] 
    # @param [Hash] opts the optional parameters
    # @return [NestedRoleResponse]
    def remove_role(container_container_remote_href, nested_role, opts = {})
      data, _status_code, _headers = remove_role_with_http_info(container_container_remote_href, nested_role, opts)
      data
    end

    # Remove a role for this object from users/groups.
    # @param container_container_remote_href [String] 
    # @param nested_role [NestedRole] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(NestedRoleResponse, Integer, Hash)>] NestedRoleResponse data, response status code and response headers
    def remove_role_with_http_info(container_container_remote_href, nested_role, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: RemotesContainerApi.remove_role ...'
      end
      # verify the required parameter 'container_container_remote_href' is set
      if @api_client.config.client_side_validation && container_container_remote_href.nil?
        fail ArgumentError, "Missing the required parameter 'container_container_remote_href' when calling RemotesContainerApi.remove_role"
      end
      # verify the required parameter 'nested_role' is set
      if @api_client.config.client_side_validation && nested_role.nil?
        fail ArgumentError, "Missing the required parameter 'nested_role' when calling RemotesContainerApi.remove_role"
      end
      # resource path
      local_var_path = '{container_container_remote_href}remove_role/'.sub('{' + 'container_container_remote_href' + '}', CGI.escape(container_container_remote_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(nested_role) 

      # return_type
      return_type = opts[:return_type] || 'NestedRoleResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: RemotesContainerApi#remove_role\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Update a container remote
    # Trigger an asynchronous update task
    # @param container_container_remote_href [String] 
    # @param container_container_remote [ContainerContainerRemote] 
    # @param [Hash] opts the optional parameters
    # @return [AsyncOperationResponse]
    def update(container_container_remote_href, container_container_remote, opts = {})
      data, _status_code, _headers = update_with_http_info(container_container_remote_href, container_container_remote, opts)
      data
    end

    # Update a container remote
    # Trigger an asynchronous update task
    # @param container_container_remote_href [String] 
    # @param container_container_remote [ContainerContainerRemote] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AsyncOperationResponse, Integer, Hash)>] AsyncOperationResponse data, response status code and response headers
    def update_with_http_info(container_container_remote_href, container_container_remote, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: RemotesContainerApi.update ...'
      end
      # verify the required parameter 'container_container_remote_href' is set
      if @api_client.config.client_side_validation && container_container_remote_href.nil?
        fail ArgumentError, "Missing the required parameter 'container_container_remote_href' when calling RemotesContainerApi.update"
      end
      # verify the required parameter 'container_container_remote' is set
      if @api_client.config.client_side_validation && container_container_remote.nil?
        fail ArgumentError, "Missing the required parameter 'container_container_remote' when calling RemotesContainerApi.update"
      end
      # resource path
      local_var_path = '{container_container_remote_href}'.sub('{' + 'container_container_remote_href' + '}', CGI.escape(container_container_remote_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(container_container_remote) 

      # return_type
      return_type = opts[:return_type] || 'AsyncOperationResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:PUT, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: RemotesContainerApi#update\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
