=begin
#Pulp 3 API

#Fetch, Upload, Organize, and Distribute Software Packages

The version of the OpenAPI document: v3
Contact: pulp-list@redhat.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.3.1

=end

require 'cgi'

module PulpContainerClient
  class RepositoriesContainerPushApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Add a role for this object to users/groups.
    # @param container_container_push_repository_href [String] 
    # @param nested_role [NestedRole] 
    # @param [Hash] opts the optional parameters
    # @return [NestedRoleResponse]
    def add_role(container_container_push_repository_href, nested_role, opts = {})
      data, _status_code, _headers = add_role_with_http_info(container_container_push_repository_href, nested_role, opts)
      data
    end

    # Add a role for this object to users/groups.
    # @param container_container_push_repository_href [String] 
    # @param nested_role [NestedRole] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(NestedRoleResponse, Integer, Hash)>] NestedRoleResponse data, response status code and response headers
    def add_role_with_http_info(container_container_push_repository_href, nested_role, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: RepositoriesContainerPushApi.add_role ...'
      end
      # verify the required parameter 'container_container_push_repository_href' is set
      if @api_client.config.client_side_validation && container_container_push_repository_href.nil?
        fail ArgumentError, "Missing the required parameter 'container_container_push_repository_href' when calling RepositoriesContainerPushApi.add_role"
      end
      # verify the required parameter 'nested_role' is set
      if @api_client.config.client_side_validation && nested_role.nil?
        fail ArgumentError, "Missing the required parameter 'nested_role' when calling RepositoriesContainerPushApi.add_role"
      end
      # resource path
      local_var_path = '{container_container_push_repository_href}add_role/'.sub('{' + 'container_container_push_repository_href' + '}', CGI.escape(container_container_push_repository_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(nested_role) 

      # return_type
      return_type = opts[:return_type] || 'NestedRoleResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: RepositoriesContainerPushApi#add_role\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # List container push repositorys
    # ViewSet for a container push repository.  POST and DELETE are disallowed because a push repository is tightly coupled with a ContainerDistribution which handles it automatically. Created - during push operation, removed - with ContainerDistribution removal.
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [String] :name 
    # @option opts [String] :name__contains Filter results where name contains value
    # @option opts [String] :name__icontains Filter results where name contains value
    # @option opts [Array<String>] :name__in Filter results where name is in a comma-separated list of values
    # @option opts [String] :name__startswith Filter results where name starts with value
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [Array<String>] :ordering Ordering
    # @option opts [String] :pulp_label_select Filter labels by search string
    # @option opts [String] :remote Foreign Key referenced by HREF
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [PaginatedcontainerContainerPushRepositoryResponseList]
    def list(opts = {})
      data, _status_code, _headers = list_with_http_info(opts)
      data
    end

    # List container push repositorys
    # ViewSet for a container push repository.  POST and DELETE are disallowed because a push repository is tightly coupled with a ContainerDistribution which handles it automatically. Created - during push operation, removed - with ContainerDistribution removal.
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [String] :name 
    # @option opts [String] :name__contains Filter results where name contains value
    # @option opts [String] :name__icontains Filter results where name contains value
    # @option opts [Array<String>] :name__in Filter results where name is in a comma-separated list of values
    # @option opts [String] :name__startswith Filter results where name starts with value
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [Array<String>] :ordering Ordering
    # @option opts [String] :pulp_label_select Filter labels by search string
    # @option opts [String] :remote Foreign Key referenced by HREF
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(PaginatedcontainerContainerPushRepositoryResponseList, Integer, Hash)>] PaginatedcontainerContainerPushRepositoryResponseList data, response status code and response headers
    def list_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: RepositoriesContainerPushApi.list ...'
      end
      allowable_values = ["-alternatecontentsourcepath", "-container_containerpushrepository", "-container_containerrepository", "-content", "-core_pulp_exporter", "-description", "-distributions", "-group_roles", "-name", "-next_version", "-pk", "-pulp_created", "-pulp_id", "-pulp_labels", "-pulp_last_updated", "-pulp_type", "-pulpimporterrepository", "-remote", "-repositorycontent", "-retain_repo_versions", "-uploads", "-user_hidden", "-user_roles", "-versions", "alternatecontentsourcepath", "container_containerpushrepository", "container_containerrepository", "content", "core_pulp_exporter", "description", "distributions", "group_roles", "name", "next_version", "pk", "pulp_created", "pulp_id", "pulp_labels", "pulp_last_updated", "pulp_type", "pulpimporterrepository", "remote", "repositorycontent", "retain_repo_versions", "uploads", "user_hidden", "user_roles", "versions"]
      if @api_client.config.client_side_validation && opts[:'ordering'] && !opts[:'ordering'].all? { |item| allowable_values.include?(item) }
        fail ArgumentError, "invalid value for \"ordering\", must include one of #{allowable_values}"
      end
      # resource path
      local_var_path = '/pulp/api/v3/repositories/container/container-push/'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'limit'] = opts[:'limit'] if !opts[:'limit'].nil?
      query_params[:'name'] = opts[:'name'] if !opts[:'name'].nil?
      query_params[:'name__contains'] = opts[:'name__contains'] if !opts[:'name__contains'].nil?
      query_params[:'name__icontains'] = opts[:'name__icontains'] if !opts[:'name__icontains'].nil?
      query_params[:'name__in'] = @api_client.build_collection_param(opts[:'name__in'], :csv) if !opts[:'name__in'].nil?
      query_params[:'name__startswith'] = opts[:'name__startswith'] if !opts[:'name__startswith'].nil?
      query_params[:'offset'] = opts[:'offset'] if !opts[:'offset'].nil?
      query_params[:'ordering'] = @api_client.build_collection_param(opts[:'ordering'], :csv) if !opts[:'ordering'].nil?
      query_params[:'pulp_label_select'] = opts[:'pulp_label_select'] if !opts[:'pulp_label_select'].nil?
      query_params[:'remote'] = opts[:'remote'] if !opts[:'remote'].nil?
      query_params[:'fields'] = opts[:'fields'] if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = opts[:'exclude_fields'] if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'PaginatedcontainerContainerPushRepositoryResponseList' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: RepositoriesContainerPushApi#list\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # List roles assigned to this object.
    # @param container_container_push_repository_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [ObjectRolesResponse]
    def list_roles(container_container_push_repository_href, opts = {})
      data, _status_code, _headers = list_roles_with_http_info(container_container_push_repository_href, opts)
      data
    end

    # List roles assigned to this object.
    # @param container_container_push_repository_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(ObjectRolesResponse, Integer, Hash)>] ObjectRolesResponse data, response status code and response headers
    def list_roles_with_http_info(container_container_push_repository_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: RepositoriesContainerPushApi.list_roles ...'
      end
      # verify the required parameter 'container_container_push_repository_href' is set
      if @api_client.config.client_side_validation && container_container_push_repository_href.nil?
        fail ArgumentError, "Missing the required parameter 'container_container_push_repository_href' when calling RepositoriesContainerPushApi.list_roles"
      end
      # resource path
      local_var_path = '{container_container_push_repository_href}list_roles/'.sub('{' + 'container_container_push_repository_href' + '}', CGI.escape(container_container_push_repository_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'fields'] = opts[:'fields'] if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = opts[:'exclude_fields'] if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'ObjectRolesResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: RepositoriesContainerPushApi#list_roles\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # List permissions available to the current user on this object.
    # @param container_container_push_repository_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [MyPermissionsResponse]
    def my_permissions(container_container_push_repository_href, opts = {})
      data, _status_code, _headers = my_permissions_with_http_info(container_container_push_repository_href, opts)
      data
    end

    # List permissions available to the current user on this object.
    # @param container_container_push_repository_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(MyPermissionsResponse, Integer, Hash)>] MyPermissionsResponse data, response status code and response headers
    def my_permissions_with_http_info(container_container_push_repository_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: RepositoriesContainerPushApi.my_permissions ...'
      end
      # verify the required parameter 'container_container_push_repository_href' is set
      if @api_client.config.client_side_validation && container_container_push_repository_href.nil?
        fail ArgumentError, "Missing the required parameter 'container_container_push_repository_href' when calling RepositoriesContainerPushApi.my_permissions"
      end
      # resource path
      local_var_path = '{container_container_push_repository_href}my_permissions/'.sub('{' + 'container_container_push_repository_href' + '}', CGI.escape(container_container_push_repository_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'fields'] = opts[:'fields'] if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = opts[:'exclude_fields'] if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'MyPermissionsResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: RepositoriesContainerPushApi#my_permissions\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Update a container push repository
    # Trigger an asynchronous partial update task
    # @param container_container_push_repository_href [String] 
    # @param patchedcontainer_container_push_repository [PatchedcontainerContainerPushRepository] 
    # @param [Hash] opts the optional parameters
    # @return [AsyncOperationResponse]
    def partial_update(container_container_push_repository_href, patchedcontainer_container_push_repository, opts = {})
      data, _status_code, _headers = partial_update_with_http_info(container_container_push_repository_href, patchedcontainer_container_push_repository, opts)
      data
    end

    # Update a container push repository
    # Trigger an asynchronous partial update task
    # @param container_container_push_repository_href [String] 
    # @param patchedcontainer_container_push_repository [PatchedcontainerContainerPushRepository] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AsyncOperationResponse, Integer, Hash)>] AsyncOperationResponse data, response status code and response headers
    def partial_update_with_http_info(container_container_push_repository_href, patchedcontainer_container_push_repository, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: RepositoriesContainerPushApi.partial_update ...'
      end
      # verify the required parameter 'container_container_push_repository_href' is set
      if @api_client.config.client_side_validation && container_container_push_repository_href.nil?
        fail ArgumentError, "Missing the required parameter 'container_container_push_repository_href' when calling RepositoriesContainerPushApi.partial_update"
      end
      # verify the required parameter 'patchedcontainer_container_push_repository' is set
      if @api_client.config.client_side_validation && patchedcontainer_container_push_repository.nil?
        fail ArgumentError, "Missing the required parameter 'patchedcontainer_container_push_repository' when calling RepositoriesContainerPushApi.partial_update"
      end
      # resource path
      local_var_path = '{container_container_push_repository_href}'.sub('{' + 'container_container_push_repository_href' + '}', CGI.escape(container_container_push_repository_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(patchedcontainer_container_push_repository) 

      # return_type
      return_type = opts[:return_type] || 'AsyncOperationResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: RepositoriesContainerPushApi#partial_update\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Inspect a container push repository
    # ViewSet for a container push repository.  POST and DELETE are disallowed because a push repository is tightly coupled with a ContainerDistribution which handles it automatically. Created - during push operation, removed - with ContainerDistribution removal.
    # @param container_container_push_repository_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [ContainerContainerPushRepositoryResponse]
    def read(container_container_push_repository_href, opts = {})
      data, _status_code, _headers = read_with_http_info(container_container_push_repository_href, opts)
      data
    end

    # Inspect a container push repository
    # ViewSet for a container push repository.  POST and DELETE are disallowed because a push repository is tightly coupled with a ContainerDistribution which handles it automatically. Created - during push operation, removed - with ContainerDistribution removal.
    # @param container_container_push_repository_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(ContainerContainerPushRepositoryResponse, Integer, Hash)>] ContainerContainerPushRepositoryResponse data, response status code and response headers
    def read_with_http_info(container_container_push_repository_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: RepositoriesContainerPushApi.read ...'
      end
      # verify the required parameter 'container_container_push_repository_href' is set
      if @api_client.config.client_side_validation && container_container_push_repository_href.nil?
        fail ArgumentError, "Missing the required parameter 'container_container_push_repository_href' when calling RepositoriesContainerPushApi.read"
      end
      # resource path
      local_var_path = '{container_container_push_repository_href}'.sub('{' + 'container_container_push_repository_href' + '}', CGI.escape(container_container_push_repository_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'fields'] = opts[:'fields'] if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = opts[:'exclude_fields'] if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'ContainerContainerPushRepositoryResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: RepositoriesContainerPushApi#read\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Delete an image from a repository
    # Trigger an asynchronous task to remove a manifest and all its associated data by a digest
    # @param container_container_push_repository_href [String] 
    # @param remove_image [RemoveImage] 
    # @param [Hash] opts the optional parameters
    # @return [AsyncOperationResponse]
    def remove_image(container_container_push_repository_href, remove_image, opts = {})
      data, _status_code, _headers = remove_image_with_http_info(container_container_push_repository_href, remove_image, opts)
      data
    end

    # Delete an image from a repository
    # Trigger an asynchronous task to remove a manifest and all its associated data by a digest
    # @param container_container_push_repository_href [String] 
    # @param remove_image [RemoveImage] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AsyncOperationResponse, Integer, Hash)>] AsyncOperationResponse data, response status code and response headers
    def remove_image_with_http_info(container_container_push_repository_href, remove_image, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: RepositoriesContainerPushApi.remove_image ...'
      end
      # verify the required parameter 'container_container_push_repository_href' is set
      if @api_client.config.client_side_validation && container_container_push_repository_href.nil?
        fail ArgumentError, "Missing the required parameter 'container_container_push_repository_href' when calling RepositoriesContainerPushApi.remove_image"
      end
      # verify the required parameter 'remove_image' is set
      if @api_client.config.client_side_validation && remove_image.nil?
        fail ArgumentError, "Missing the required parameter 'remove_image' when calling RepositoriesContainerPushApi.remove_image"
      end
      # resource path
      local_var_path = '{container_container_push_repository_href}remove_image/'.sub('{' + 'container_container_push_repository_href' + '}', CGI.escape(container_container_push_repository_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(remove_image) 

      # return_type
      return_type = opts[:return_type] || 'AsyncOperationResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: RepositoriesContainerPushApi#remove_image\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Remove a role for this object from users/groups.
    # @param container_container_push_repository_href [String] 
    # @param nested_role [NestedRole] 
    # @param [Hash] opts the optional parameters
    # @return [NestedRoleResponse]
    def remove_role(container_container_push_repository_href, nested_role, opts = {})
      data, _status_code, _headers = remove_role_with_http_info(container_container_push_repository_href, nested_role, opts)
      data
    end

    # Remove a role for this object from users/groups.
    # @param container_container_push_repository_href [String] 
    # @param nested_role [NestedRole] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(NestedRoleResponse, Integer, Hash)>] NestedRoleResponse data, response status code and response headers
    def remove_role_with_http_info(container_container_push_repository_href, nested_role, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: RepositoriesContainerPushApi.remove_role ...'
      end
      # verify the required parameter 'container_container_push_repository_href' is set
      if @api_client.config.client_side_validation && container_container_push_repository_href.nil?
        fail ArgumentError, "Missing the required parameter 'container_container_push_repository_href' when calling RepositoriesContainerPushApi.remove_role"
      end
      # verify the required parameter 'nested_role' is set
      if @api_client.config.client_side_validation && nested_role.nil?
        fail ArgumentError, "Missing the required parameter 'nested_role' when calling RepositoriesContainerPushApi.remove_role"
      end
      # resource path
      local_var_path = '{container_container_push_repository_href}remove_role/'.sub('{' + 'container_container_push_repository_href' + '}', CGI.escape(container_container_push_repository_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(nested_role) 

      # return_type
      return_type = opts[:return_type] || 'NestedRoleResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: RepositoriesContainerPushApi#remove_role\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Create a task which deletes signatures by the passed key_id.
    # @param container_container_push_repository_href [String] 
    # @param remove_signatures [RemoveSignatures] 
    # @param [Hash] opts the optional parameters
    # @return [RemoveSignaturesResponse]
    def remove_signatures(container_container_push_repository_href, remove_signatures, opts = {})
      data, _status_code, _headers = remove_signatures_with_http_info(container_container_push_repository_href, remove_signatures, opts)
      data
    end

    # Create a task which deletes signatures by the passed key_id.
    # @param container_container_push_repository_href [String] 
    # @param remove_signatures [RemoveSignatures] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(RemoveSignaturesResponse, Integer, Hash)>] RemoveSignaturesResponse data, response status code and response headers
    def remove_signatures_with_http_info(container_container_push_repository_href, remove_signatures, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: RepositoriesContainerPushApi.remove_signatures ...'
      end
      # verify the required parameter 'container_container_push_repository_href' is set
      if @api_client.config.client_side_validation && container_container_push_repository_href.nil?
        fail ArgumentError, "Missing the required parameter 'container_container_push_repository_href' when calling RepositoriesContainerPushApi.remove_signatures"
      end
      # verify the required parameter 'remove_signatures' is set
      if @api_client.config.client_side_validation && remove_signatures.nil?
        fail ArgumentError, "Missing the required parameter 'remove_signatures' when calling RepositoriesContainerPushApi.remove_signatures"
      end
      # resource path
      local_var_path = '{container_container_push_repository_href}remove_signatures/'.sub('{' + 'container_container_push_repository_href' + '}', CGI.escape(container_container_push_repository_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(remove_signatures) 

      # return_type
      return_type = opts[:return_type] || 'RemoveSignaturesResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: RepositoriesContainerPushApi#remove_signatures\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Sign images in the repo
    # Trigger an asynchronous task to sign content.
    # @param container_container_push_repository_href [String] 
    # @param repository_sign [RepositorySign] 
    # @param [Hash] opts the optional parameters
    # @return [AsyncOperationResponse]
    def sign(container_container_push_repository_href, repository_sign, opts = {})
      data, _status_code, _headers = sign_with_http_info(container_container_push_repository_href, repository_sign, opts)
      data
    end

    # Sign images in the repo
    # Trigger an asynchronous task to sign content.
    # @param container_container_push_repository_href [String] 
    # @param repository_sign [RepositorySign] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AsyncOperationResponse, Integer, Hash)>] AsyncOperationResponse data, response status code and response headers
    def sign_with_http_info(container_container_push_repository_href, repository_sign, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: RepositoriesContainerPushApi.sign ...'
      end
      # verify the required parameter 'container_container_push_repository_href' is set
      if @api_client.config.client_side_validation && container_container_push_repository_href.nil?
        fail ArgumentError, "Missing the required parameter 'container_container_push_repository_href' when calling RepositoriesContainerPushApi.sign"
      end
      # verify the required parameter 'repository_sign' is set
      if @api_client.config.client_side_validation && repository_sign.nil?
        fail ArgumentError, "Missing the required parameter 'repository_sign' when calling RepositoriesContainerPushApi.sign"
      end
      # resource path
      local_var_path = '{container_container_push_repository_href}sign/'.sub('{' + 'container_container_push_repository_href' + '}', CGI.escape(container_container_push_repository_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(repository_sign) 

      # return_type
      return_type = opts[:return_type] || 'AsyncOperationResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: RepositoriesContainerPushApi#sign\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Create a Tag
    # Trigger an asynchronous task to tag an image in the repository
    # @param container_container_push_repository_href [String] 
    # @param tag_image [TagImage] 
    # @param [Hash] opts the optional parameters
    # @return [AsyncOperationResponse]
    def tag(container_container_push_repository_href, tag_image, opts = {})
      data, _status_code, _headers = tag_with_http_info(container_container_push_repository_href, tag_image, opts)
      data
    end

    # Create a Tag
    # Trigger an asynchronous task to tag an image in the repository
    # @param container_container_push_repository_href [String] 
    # @param tag_image [TagImage] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AsyncOperationResponse, Integer, Hash)>] AsyncOperationResponse data, response status code and response headers
    def tag_with_http_info(container_container_push_repository_href, tag_image, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: RepositoriesContainerPushApi.tag ...'
      end
      # verify the required parameter 'container_container_push_repository_href' is set
      if @api_client.config.client_side_validation && container_container_push_repository_href.nil?
        fail ArgumentError, "Missing the required parameter 'container_container_push_repository_href' when calling RepositoriesContainerPushApi.tag"
      end
      # verify the required parameter 'tag_image' is set
      if @api_client.config.client_side_validation && tag_image.nil?
        fail ArgumentError, "Missing the required parameter 'tag_image' when calling RepositoriesContainerPushApi.tag"
      end
      # resource path
      local_var_path = '{container_container_push_repository_href}tag/'.sub('{' + 'container_container_push_repository_href' + '}', CGI.escape(container_container_push_repository_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(tag_image) 

      # return_type
      return_type = opts[:return_type] || 'AsyncOperationResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: RepositoriesContainerPushApi#tag\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Delete a tag
    # Trigger an asynchronous task to untag an image in the repository
    # @param container_container_push_repository_href [String] 
    # @param un_tag_image [UnTagImage] 
    # @param [Hash] opts the optional parameters
    # @return [AsyncOperationResponse]
    def untag(container_container_push_repository_href, un_tag_image, opts = {})
      data, _status_code, _headers = untag_with_http_info(container_container_push_repository_href, un_tag_image, opts)
      data
    end

    # Delete a tag
    # Trigger an asynchronous task to untag an image in the repository
    # @param container_container_push_repository_href [String] 
    # @param un_tag_image [UnTagImage] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AsyncOperationResponse, Integer, Hash)>] AsyncOperationResponse data, response status code and response headers
    def untag_with_http_info(container_container_push_repository_href, un_tag_image, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: RepositoriesContainerPushApi.untag ...'
      end
      # verify the required parameter 'container_container_push_repository_href' is set
      if @api_client.config.client_side_validation && container_container_push_repository_href.nil?
        fail ArgumentError, "Missing the required parameter 'container_container_push_repository_href' when calling RepositoriesContainerPushApi.untag"
      end
      # verify the required parameter 'un_tag_image' is set
      if @api_client.config.client_side_validation && un_tag_image.nil?
        fail ArgumentError, "Missing the required parameter 'un_tag_image' when calling RepositoriesContainerPushApi.untag"
      end
      # resource path
      local_var_path = '{container_container_push_repository_href}untag/'.sub('{' + 'container_container_push_repository_href' + '}', CGI.escape(container_container_push_repository_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(un_tag_image) 

      # return_type
      return_type = opts[:return_type] || 'AsyncOperationResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: RepositoriesContainerPushApi#untag\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Update a container push repository
    # Trigger an asynchronous update task
    # @param container_container_push_repository_href [String] 
    # @param container_container_push_repository [ContainerContainerPushRepository] 
    # @param [Hash] opts the optional parameters
    # @return [AsyncOperationResponse]
    def update(container_container_push_repository_href, container_container_push_repository, opts = {})
      data, _status_code, _headers = update_with_http_info(container_container_push_repository_href, container_container_push_repository, opts)
      data
    end

    # Update a container push repository
    # Trigger an asynchronous update task
    # @param container_container_push_repository_href [String] 
    # @param container_container_push_repository [ContainerContainerPushRepository] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AsyncOperationResponse, Integer, Hash)>] AsyncOperationResponse data, response status code and response headers
    def update_with_http_info(container_container_push_repository_href, container_container_push_repository, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: RepositoriesContainerPushApi.update ...'
      end
      # verify the required parameter 'container_container_push_repository_href' is set
      if @api_client.config.client_side_validation && container_container_push_repository_href.nil?
        fail ArgumentError, "Missing the required parameter 'container_container_push_repository_href' when calling RepositoriesContainerPushApi.update"
      end
      # verify the required parameter 'container_container_push_repository' is set
      if @api_client.config.client_side_validation && container_container_push_repository.nil?
        fail ArgumentError, "Missing the required parameter 'container_container_push_repository' when calling RepositoriesContainerPushApi.update"
      end
      # resource path
      local_var_path = '{container_container_push_repository_href}'.sub('{' + 'container_container_push_repository_href' + '}', CGI.escape(container_container_push_repository_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(container_container_push_repository) 

      # return_type
      return_type = opts[:return_type] || 'AsyncOperationResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:PUT, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: RepositoriesContainerPushApi#update\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
